package polish_community_group_11.polish_community.register;

import polish_community_group_11.polish_community.register.dao.UserRepository;
import polish_community_group_11.polish_community.register.services.UserServiceImpl; // Assuming UserServiceImpl is the correct implementation
import polish_community_group_11.polish_community.register.models.User;

import org.junit.jupiter.api.Test;
import org.mockito.InjectMocks;
import org.mockito.Mock;
import org.mockito.MockitoAnnotations;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.time.LocalDate;
import static org.mockito.Mockito.*;
import static org.junit.jupiter.api.Assertions.*;
import org.junit.jupiter.api.extension.ExtendWith;
import org.mockito.junit.jupiter.MockitoExtension;

@ExtendWith(MockitoExtension.class)
public class RegisterTest {

    @Mock
    private UserRepository userRepository; // Mocking the UserRepository

    @InjectMocks
    private UserServiceImpl userService; // Injecting mock into the service

    @Test
    public void testFindAllUsers() {
        System.out.println("Starting testFindAllUsers...");
        // Arrange: Create a mock user using setters
        List<User> mockUsers = new ArrayList<>();
        User user = new User();
        user.setId(1);
        user.setEmail("test@example.com");
        user.setPassword("password");
        user.setFullname("John Doe");
        user.setDateOfBirth(LocalDate.of(1990, 1, 1));
        user.setRoleId(1);
        
        mockUsers.add(user);
    
        // Mock the findAllUsers method to return the mock users
        when(userRepository.findAllUsers()).thenReturn(mockUsers);
    
        // Act: Call the service method
        List<User> users = userService.findAllUsers();
        System.out.println("Returned users: " + users);
    
        // Assert: Verify that the result is not null, contains the expected users, and is not empty
        assertNotNull(users);
        assertFalse(users.isEmpty());
        assertEquals(1, users.size()); // Expecting 1 user

        System.out.println("Test completed successfully. Found " + users.size() + " users.");
    }
}
